﻿// <auto-generated />
using System;
using DataLayer.Entities;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

#nullable disable

namespace DataLayer.Migrations
{
    [DbContext(typeof(FMContext))]
    partial class FMContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "7.0.5")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            SqlServerModelBuilderExtensions.UseIdentityColumns(modelBuilder);

            modelBuilder.Entity("DataLayer.Entities.Booking", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("id")
                        .HasDefaultValueSql("(newid())");

                    b.Property<Guid>("ClientId")
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("client_id");

                    b.Property<DateTime>("EndDate")
                        .HasColumnType("date")
                        .HasColumnName("end_date");

                    b.Property<bool>("IsDeleted")
                        .HasColumnType("bit")
                        .HasColumnName("is_deleted");

                    b.Property<decimal?>("Price")
                        .HasColumnType("decimal(18, 6)")
                        .HasColumnName("price");

                    b.Property<Guid>("SpaceId")
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("space_id");

                    b.Property<DateTime>("StartDate")
                        .HasColumnType("date")
                        .HasColumnName("start_date");

                    b.HasKey("Id")
                        .HasName("PK__Bookings__3213E83F9FFBEAD0");

                    b.HasIndex("ClientId");

                    b.HasIndex("SpaceId");

                    b.HasIndex(new[] { "EndDate" }, "idx_end_date");

                    b.HasIndex(new[] { "StartDate" }, "idx_start_date");

                    b.ToTable("Bookings");
                });

            modelBuilder.Entity("DataLayer.Entities.Client", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("id")
                        .HasDefaultValueSql("(newid())");

                    b.Property<string>("Email")
                        .HasMaxLength(255)
                        .HasColumnType("nvarchar(255)")
                        .HasColumnName("email");

                    b.Property<bool>("IsDeleted")
                        .HasColumnType("bit")
                        .HasColumnName("is_deleted");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("nvarchar(255)")
                        .HasColumnName("name");

                    b.Property<string>("Number")
                        .HasMaxLength(255)
                        .HasColumnType("nvarchar(255)")
                        .HasColumnName("number");

                    b.Property<string>("Pin")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("nvarchar(255)")
                        .HasColumnName("pin");

                    b.HasKey("Id")
                        .HasName("PK__Clients__3213E83F939529DA");

                    b.ToTable("Clients");
                });

            modelBuilder.Entity("DataLayer.Entities.Consumable", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("id")
                        .HasDefaultValueSql("(newid())");

                    b.Property<string>("BaseUnit")
                        .IsRequired()
                        .ValueGeneratedOnAdd()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)")
                        .HasColumnName("base_unit")
                        .HasDefaultValueSql("('????')");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("nvarchar(255)")
                        .HasColumnName("name");

                    b.Property<decimal>("Price")
                        .HasColumnType("decimal(18, 6)")
                        .HasColumnName("price");

                    b.HasKey("Id")
                        .HasName("PK__Consumab__3213E83F81613B68");

                    b.ToTable("Consumables");
                });

            modelBuilder.Entity("DataLayer.Entities.Invoice", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("id")
                        .HasDefaultValueSql("(newid())");

                    b.Property<decimal?>("Amount")
                        .HasColumnType("decimal(18, 6)")
                        .HasColumnName("amount");

                    b.Property<Guid>("BookingId")
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("booking_id");

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("date")
                        .HasColumnName("created_at");

                    b.Property<string>("InvoiceNumber")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("nvarchar(255)")
                        .HasColumnName("invoice_number");

                    b.Property<bool>("Paid")
                        .HasColumnType("bit")
                        .HasColumnName("paid");

                    b.HasKey("Id")
                        .HasName("PK__Invoices__3213E83F4E068D41");

                    b.HasIndex("BookingId");

                    b.ToTable("Invoices");
                });

            modelBuilder.Entity("DataLayer.Entities.InvoiceConsumable", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("id")
                        .HasDefaultValueSql("(newid())");

                    b.Property<decimal>("Count")
                        .HasColumnType("decimal(10, 5)")
                        .HasColumnName("count");

                    b.Property<Guid>("InvoiceId")
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("invoiceId");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("nchar(255)")
                        .HasColumnName("name")
                        .IsFixedLength();

                    b.Property<decimal>("Price")
                        .HasColumnType("decimal(10, 5)")
                        .HasColumnName("price");

                    b.HasKey("Id");

                    b.HasIndex("InvoiceId");

                    b.ToTable("Invoice_consumables");
                });

            modelBuilder.Entity("DataLayer.Entities.Space", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("id")
                        .HasDefaultValueSql("(newid())");

                    b.Property<string>("Description")
                        .HasColumnType("nvarchar(max)")
                        .HasColumnName("description");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasMaxLength(50)
                        .HasColumnType("nvarchar(50)")
                        .HasColumnName("name");

                    b.Property<double>("Size")
                        .HasColumnType("float")
                        .HasColumnName("size");

                    b.Property<double>("Volume")
                        .HasColumnType("float")
                        .HasColumnName("volume");

                    b.HasKey("Id")
                        .HasName("PK__Spaces__3213E83FABADB916");

                    b.HasIndex(new[] { "Name" }, "UC_Spaces_Name")
                        .IsUnique();

                    b.ToTable("Spaces");
                });

            modelBuilder.Entity("DataLayer.Entities.SpaceConsumable", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("id")
                        .HasDefaultValueSql("(newid())");

                    b.Property<Guid>("ConsumablesId")
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("consumables_id");

                    b.Property<int?>("Count")
                        .HasColumnType("int")
                        .HasColumnName("count");

                    b.Property<Guid>("SpaceId")
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("space_id");

                    b.HasKey("Id")
                        .HasName("PK__Space_co__3213E83F3C82E39F");

                    b.HasIndex("ConsumablesId");

                    b.HasIndex("SpaceId");

                    b.ToTable("Space_consumables");
                });

            modelBuilder.Entity("DataLayer.Entities.User", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("uniqueidentifier")
                        .HasColumnName("id")
                        .HasDefaultValueSql("(newid())");

                    b.Property<string>("Password")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("nvarchar(255)")
                        .HasColumnName("password");

                    b.Property<byte>("Role")
                        .HasColumnType("tinyint")
                        .HasColumnName("role");

                    b.Property<string>("Username")
                        .IsRequired()
                        .HasMaxLength(255)
                        .HasColumnType("nvarchar(255)")
                        .HasColumnName("username");

                    b.HasKey("Id")
                        .HasName("PK__Users__3213E83F8D48FA7B");

                    b.ToTable("Users");
                });

            modelBuilder.Entity("DataLayer.Entities.Booking", b =>
                {
                    b.HasOne("DataLayer.Entities.Client", "Client")
                        .WithMany("Bookings")
                        .HasForeignKey("ClientId")
                        .IsRequired()
                        .HasConstraintName("FK__Bookings__client__5BE2A6F2");

                    b.HasOne("DataLayer.Entities.Space", "Space")
                        .WithMany("Bookings")
                        .HasForeignKey("SpaceId")
                        .IsRequired()
                        .HasConstraintName("FK__Bookings__space___4AB81AF0");

                    b.Navigation("Client");

                    b.Navigation("Space");
                });

            modelBuilder.Entity("DataLayer.Entities.Invoice", b =>
                {
                    b.HasOne("DataLayer.Entities.Booking", "Booking")
                        .WithMany("Invoices")
                        .HasForeignKey("BookingId")
                        .IsRequired()
                        .HasConstraintName("FK_Invoices_Bookings");

                    b.Navigation("Booking");
                });

            modelBuilder.Entity("DataLayer.Entities.InvoiceConsumable", b =>
                {
                    b.HasOne("DataLayer.Entities.Invoice", "Invoice")
                        .WithMany("InvoiceConsumables")
                        .HasForeignKey("InvoiceId")
                        .IsRequired()
                        .HasConstraintName("FK__InvoiceCo__Invoi__1BC821DD");

                    b.Navigation("Invoice");
                });

            modelBuilder.Entity("DataLayer.Entities.SpaceConsumable", b =>
                {
                    b.HasOne("DataLayer.Entities.Consumable", "Consumables")
                        .WithMany("SpaceConsumables")
                        .HasForeignKey("ConsumablesId")
                        .IsRequired()
                        .HasConstraintName("FK__Space_con__consu__3A81B327");

                    b.HasOne("DataLayer.Entities.Space", "Space")
                        .WithMany("SpaceConsumables")
                        .HasForeignKey("SpaceId")
                        .IsRequired()
                        .HasConstraintName("FK__Space_con__space__4F7CD00D");

                    b.Navigation("Consumables");

                    b.Navigation("Space");
                });

            modelBuilder.Entity("DataLayer.Entities.Booking", b =>
                {
                    b.Navigation("Invoices");
                });

            modelBuilder.Entity("DataLayer.Entities.Client", b =>
                {
                    b.Navigation("Bookings");
                });

            modelBuilder.Entity("DataLayer.Entities.Consumable", b =>
                {
                    b.Navigation("SpaceConsumables");
                });

            modelBuilder.Entity("DataLayer.Entities.Invoice", b =>
                {
                    b.Navigation("InvoiceConsumables");
                });

            modelBuilder.Entity("DataLayer.Entities.Space", b =>
                {
                    b.Navigation("Bookings");

                    b.Navigation("SpaceConsumables");
                });
#pragma warning restore 612, 618
        }
    }
}
